
SET(SMV_SEARCH_PATHS 
	${CMAKE_SOURCE_DIR}/ThirdParty/libsmv/build/lib
	${CMAKE_SOURCE_DIR}/../ThirdParty/libsmv/build/lib
    ${CMAKE_SOURCE_DIR}/ThirdParty/dist/build/lib
    ${CMAKE_SOURCE_DIR}/../ThirdParty/dist/build/lib)

FIND_PATH(SMV_INCLUDE_DIR NAMES smv.h PATHS ${SMV_SEARCH_PATHS})
FIND_LIBRARY(SMV_LIBRARY NAMES smv PATHS ${SMV_SEARCH_PATHS})


SET(SMV_FOUND FALSE)
IF (SMV_LIBRARY)
  SET(SMV_FOUND TRUE)
  INCLUDE_DIRECTORIES(${SMV_INCLUDE_DIR})
  MARK_AS_ADVANCED(SMV_LIBRARY)
  MARK_AS_ADVANCED(SMV_INCLUDE_DIR)
ENDIF (SMV_LIBRARY)

IF (SMV_FOUND)
  IF (NOT SMV_FIND_QUIETLY)
     MESSAGE(STATUS "Found SMV: ${SMV_INCLUDE_DIR}")
  ENDIF (NOT SMV_FIND_QUIETLY)
ELSE(SMV_FOUND)
  IF (SMV_FIND_REQUIRED)
     MESSAGE(FATAL_ERROR "Could not find SMV")
  ENDIF (SMV_FIND_REQUIRED)
ENDIF (SMV_FOUND)
